/*
 * Copyright (c) 1997-2007 Erez Zadok <ezk@cs.stonybrook.edu>
 * Copyright (c) 2001-2007 Stony Brook University
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package, or get one from
 * ftp://ftp.filesystems.org/pub/fistgen/COPYING.
 *
 * This Copyright notice must be kept intact and distributed with all
 * fistgen sources INCLUDING sources generated by fistgen.
 *
 *
 * File: fistgen/misc.c
 *
 * miscellaneous functions
 * Fistgen sources.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */


/* lowercase a whole string (in-place) */
void
lowercase_string(char *str)
{
  char *cp = str;

  if (!str)
    return;
  do {
    *cp = tolower(*cp);
  } while (*cp++);
}


/* uppercase a whole string (in-place) */
void
uppercase_string(char *str)
{
  char *cp = str;

  if (!str)
    return;
  do {
    *cp = toupper(*cp);
  } while (*cp++);
}
